/* 
 * Lexical tokenizer for XML 
 * 2002-2003 HShivanan
 * 
 * For licensing terms, see the file COPYING in this directory
 * For contact information, see the file AUTHORS in this directory
 *
 */

#include <assert.h>
#include "xmlscan.h"
#include <string.h>
#include "stuff.h"

#define SCAN_XML
#include "scan.h"
#undef SCAN_XML
static void scannull(XML_SCANNER *scanner)
{
	scanner->tokenid=_NULL;
}

static void specify_tag(XML_SCANNER *scanner,char *str,TOKENTYPE tt)
{
	int i;
	int len;
	len=strlen(str);
	if (strlen(scanner->token)+1<len)
		return;
	for (i=0;i<len;++i)if (str[i]!=scanner->token[i+1])return;
	scanner->tokenid=tt;
}
#define SPECIFY_TAG2(o,c,t) specify_tag(scanner,o,t##_O);specify_tag(scanner,c,t##_C)
#define SPECIFY_TAG(o,t) specify_tag(scanner,o,t)
static void scantag(XML_SCANNER *scanner)
{
	scanner->tokenid=TAGOPEN;
	nextchar(scanner);
	if (scanner->ahead=='/')
	{
		scanner->tokenid=TAGCLOSE;
		nextchar(scanner);
	}
	while (scanner->ahead!='>' &&
			scanner->ahead!=0)
		nextchar(scanner);
	SPECIFY_TAG2("item","/item",ITEM);	
	SPECIFY_TAG2("description","/description",DESCRIPTION);
	SPECIFY_TAG2("title","/title",TITLE);
	SPECIFY_TAG2("link","/link",LINK);
	SPECIFY_TAG2("channel","/channel",CHANNEL);
	SPECIFY_TAG2("rss","/rss",RSS);
	SPECIFY_TAG2("rdf","/rdf",RDF);
	SPECIFY_TAG("?xml",XML);
	SPECIFY_TAG("!DOCTYPE",DOCTYPE);
	SPECIFY_TAG("!--",COMMENT);
	nextchar(scanner);
}
static void scandef(XML_SCANNER *scanner)
{
	while (scanner->ahead!='<' &&
			scanner->ahead!=0)
		nextchar(scanner);
	//nextchar(scanner);
	scanner->tokenid=TEXT;
}

void xml_nexttoken(XML_SCANNER *scanner)
{
	scanner->token[0]=scanner->count=0;
	scanner->ahead=*scanner->code;
	if (iswhitespace(scanner,scanner->ahead)) eatwhitespace(scanner);
	switch (scanner->ahead)
	{
		case '<':scantag(scanner);break;
		case 0  :scannull(scanner);break;
		default: scandef(scanner);
	}
	scanner->token[scanner->count]=0;
}
